#include<iostream>
#include<fstream>
#include<math.h>

using namespace std;

#include "Modell.h"
#include "IntegratorRuKu.h"

#include "stdlib.h"

int main()
{
    Modell* modell                  = new Modell();
    IntegratorRuKu* integrator  = new IntegratorRuKu(modell);

    double t=0.0;
    double dt=0.1;
    double tmax = 50.0;

    double* yneu;
    double  yalt[1] = {0.0};
    double u=0.0;

    int schritte = 1+(int)(tmax/dt);    

    ofstream fout("data.txt");
    for(int i=0;i<schritte;i++)
    {
        u=sin(t);
        fout<<t<<" "<<u<<" "<<yalt[0]<<endl;

        u = sin(t);
        yneu = integrator->zeitschritt(yalt,u,dt);

        for(int i=0;i<modell->holeAnzahlGleichungen();i++)
            yalt[i] = yneu[i];

        t=t+dt;
    }
    fout.close();
    system("scilab -f plotter.sce");    
}
